/**************************************************************************
 *
 * Copyright (C) 2015 Thorsten Falk
 *
 *        Image Analysis Lab, University of Freiburg, Germany
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 **************************************************************************/

#ifndef CONVERTMASKSTOMARKERSWORKER_HH
#define CONVERTMASKSTOMARKERSWORKER_HH

#ifdef HAVE_CONFIG_H
#include <config.hh>
#endif

#include <libProgressReporter/ProgressReporterQt4.hh>

#include <QtCore/QThread>

class ConvertMasksToMarkersParameters;
class LabellingMainWidget;
class AnnotationChannelSpecs;
class VisualizationChannelSpecs;

class ConvertMasksToMarkersWorker : public QThread
{

  Q_OBJECT

  public:
  
  ConvertMasksToMarkersWorker(
      ConvertMasksToMarkersParameters* dialog, LabellingMainWidget* mainWidget,
      AnnotationChannelSpecs* markerChannel,
      iRoCS::ProgressReporterQt4* progress, QWidget* parent = 0);
  ~ConvertMasksToMarkersWorker();

  void run();

  void abort();
  
private:

  ConvertMasksToMarkersParameters* p_dialog;
  LabellingMainWidget* p_mainWidget;
  AnnotationChannelSpecs* p_markerChannel;
  iRoCS::ProgressReporterQt4 *p_progress;

};

#endif
